//Components.utils.import("resource://gre/modules/PopupNotifications.jsm");
//Components.utils.import("resource://gre/modules/Services.jsm");

var BDQSAddonsListener = new function() {
    this.ClearPrefs = function() {
        /*var prefs = Components.classes["@mozilla.org/preferences-service;1"]
            .getService(Components.interfaces.nsIPrefService)
            .getBranch("extensions.bdqscan.");
        prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
        prefs.addObserver("", this, false);

        prefs.setIntPref("numberOfDays", 0);
        prefs.setIntPref("lastScanDate", 0);
        prefs.setIntPref("lastActionDate", 0);*/
        var prefs = Components.classes["@mozilla.org/preferences-service;1"]
            .getService(Components.interfaces.nsIPrefService)
            .getBranch("extensions.bdqscan.");
        prefs.QueryInterface(Components.interfaces.nsIPrefBranch);
        prefs.clearUserPref("numberOfDays");
        prefs.clearUserPref("lastScanDate");
        prefs.clearUserPref("lastActionDate");
        prefs.deleteBranch("");
    }

    this.onUninstalling = function(addon) {
	if (addon.name == "Bitdefender QuickScan") {
            this.ClearPrefs();
        }
    }
	
    this._uninstall = false

    this.observe = function(subject, topic, data) {
        if (topic == "em-action-requested") {
            subject.QueryInterface(Components.interfaces.nsIUpdateItem);

            if (subject.id == "{e001c731-5e37-4538-a5cb-8168736a2360}") {
                if (data == "item-uninstalled") {
                    this._uninstall = true;
                } else if (data == "item-cancel-action") {
                    this._uninstall = false;
                }
            }
        } else if (topic == "quit-application-granted") {
            if (this._uninstall) {
                this.ClearPrefs();
            }
            this.Unregister();
        }    
    }

    this.Register = function() {
        try {
            Components.utils.import("resource://gre/modules/AddonManager.jsm");
            AddonManager.addAddonListener(this);
        } catch (ex) {
            var observerService = Components.classes["@mozilla.org/observer-service;1"]
                .getService (Components.interfaces.nsIObserverService);
            observerService.addObserver(BDQSAddonsListener, "experimental-notify-plugin-call", false);
        }
    }

    this.Unregister = function() {
        var observerService = Components.classes["@mozilla.org/observer-service;1"]
            .getService(Components.interfaces.nsIObserverService);

        observerService.removeObserver(BDQSAddonsListener,"em-action-requested");
        observerService.removeObserver(BDQSAddonsListener,"quit-application-granted");
    }
}



var BDQScan = new function() {
	
    this.MyOnLoad = function() {
        try {
            /* this won't get through AMO

            var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService();
            prefService = prefService.QueryInterface(Components.interfaces.nsIPrefService);
            
            var prefBranch = prefService.getBranch(null);
            prefBranch.setIntPref("alerts.totalOpenTime",100000);*/

            BDQSAddonsListener.Register();

            document.getElementById("BDQS_drop_contents_id").style.display = "none";

            this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
                .getService(Components.interfaces.nsIPrefService)
                .getBranch("extensions.bdqscan.");

            this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
            this.prefs.addObserver("", this, false);
			
            this.MyAttachButton();

            this.ValidateStorage();
            this.CheckLastScanDate();
        } catch(e) {}
    }

    this.ValidateStorage = function() {
        var now = Date.now().toString();
        if ("" == this.prefs.getCharPref('lastScanDate')) {
            this.prefs.setCharPref('lastScanDate', now);
        }

        if ("" == this.prefs.getCharPref('lastActionDate')) {
            this.prefs.setCharPref('lastActionDate', now);
        }

	if (0 == this.prefs.getIntPref('numberOfDays')) {
            this.prefs.setIntPref('numberOfDays', 14);
        }
    }


    // Clean up after ourselves and save the prefs
    this.MyOnUnload = function() {
        this.prefs.removeObserver("", this); 
		
    }
    
    this.UpdateScanDate = function() {
	var now = Date.now().toString();
	this.prefs.setCharPref('lastScanDate', now);
	this.prefs.setCharPref('lastActionDate', now);
    }

    this.UpdateActionDate = function() {
	this.prefs.setCharPref('lastActionDate', Date.now().toString());
    }

    this.SetNotificationInterval = function(days) {
        this.UpdateActionDate();
        this.prefs.setIntPref('numberOfDays', days);
    }
	
    //Compare the last scan date and the days passed since with current date
    this.IsItNotificationTime = function() {
        var CurrentDate = Date.now();
        var NextScanDate = parseInt(this.prefs.getCharPref('lastActionDate')) + 1000 * 60 * 60 * 24 * this.prefs.getIntPref('numberOfDays');
        return NextScanDate <= CurrentDate;
    }

    this.HandleMenu = function() {
        var menu = document.getElementById("BDQS_drop_contents_id");
        var state = menu.style.display;
        if(state == "none") {
            menu.style.display = "block";
            document.getElementById('BDQS_darrow_state').setAttribute("class", "darrow collapsed");
        } else {
            menu.style.display = "none";	
            document.getElementById('BDQS_darrow_state').setAttribute("class", "darrow expanded");
        }	
    }
	
	//check if the notification must be displayed
    this.CheckLastScanDate = function() {		
        if (true == this.IsItNotificationTime()) {
	    this.ShowNotification();
	}

        setTimeout(BDQScan.CheckLastScanDate, 3 * 60 * 60 * 1000);
    }
	
    this.makeURI = function(aURL, aOriginCharset, aBaseURI) {
        var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        return ioService.newURI(aURL, aOriginCharset, aBaseURI);
    }
	
    this.ShowNotification = function() {	
        //var mainWindow = this.MyGetWindow();
        var left = {};
        var top = {};
        var width = {};
        var height = {};
        Components.classes["@mozilla.org/gfx/screenmanager;1"].getService(Components.interfaces.nsIScreenManager)
            .primaryScreen.GetAvailRect(left, top, width, height);
        
        document.getElementById("BDQS_alert_panel").openPopupAtScreen(width.value - 310, height.value - 140, false);
           
        var stringBundle = document.getElementById("bdqscan-string-bundle");

        ["BDQS_notificationText", "BDQS_optText", "BDQS_opt3", "BDQS_opt4", "BDQS_opt5"].forEach(function(o) {
            document.getElementById(o).textContent = stringBundle.getString(o);
        });

        //document.getElementById("info").textContent  = stringBundle.getString('notif_text1')+"";
        //document.getElementById("textOption").textContent  = stringBundle.getString('ScanNow')+"";
    }

    this.HideNotification = function() {
        var panel = document.getElementById("BDQS_alert_panel");
        if(panel != null) {
            panel.hidePopup();
        }
    }

    this.PostponeNotification = function(days) {
        this.SetNotificationInterval(days);
        this.UpdateActionDate();
        this.HideNotification();
    }

    this.StartScan = function() {
	this.HideNotification();
	this.UpdateScanDate();
        gBrowser.selectedTab = gBrowser.addTab('http://quickscan.bitdefender.com/?autostart=1');
    }

    this.MyAttachButton = function() {
        var elements = document.getElementsByTagName("*");
        var found = false;
        for (i=0; i<elements.length; i++) {
            var firefoxbar = elements[i];

            if (!firefoxbar.className || !firefoxbar.currentSet)
                continue;

            if (firefoxbar.className.toString().indexOf("chromeclass-toolbar") < 0)
                continue;

            if (firefoxbar.currentSet.indexOf("bdqscan-1") >= 0) {
                if(!firefoxbar.collapsed) {
                    found = true;
                    break;
                }
            }
        }

        if(!found) {
            var firefoxbar = document.getElementById("nav-bar");
            var curSet = firefoxbar.currentSet;

            var set;
            if (curSet.indexOf("search-container") >= 0)
                set = curSet.replace(/search-container/, "search-container,bdqscan-1");
            else
                set = curSet + ",bdqscan-1";
    
            firefoxbar.setAttribute("currentset", set);
            firefoxbar.currentSet = set;
            document.persist("nav-bar", "currentset");

            BrowserToolboxCustomizeDone(true);
        }
    }

    this.MyDetachButton = function() {
        var elements = document.getElementsByTagName("*");
        var found = false;
        for (i=0; i<elements.length; i++) {
            var firefoxbar = elements[i];

            if (!firefoxbar.className || !firefoxbar.currentSet)
                continue;

            if (firefoxbar.className.toString().indexOf("chromeclass-toolbar") < 0)
                continue;
                
            var curSet = firefoxbar.currentSet.split(",");
            var p = curSet.indexOf("bdqscan-1");
            
            
            if (p >= 0) {
                do {
                    curSet.splice(p, 1);
                    p = curSet.indexOf("bdqscan-1");
                } while (p >= 0);
            }
            
            var set = curSet.join();
            firefoxbar.setAttribute("currentset", set);
            firefoxbar.currentSet = set;
            window.persist(firefoxbar.id, "currentset");
            
            BrowserToolboxCustomizeDone(true);
        }
    }

    this.MyGetWindow = function() {
        return Components.classes["@mozilla.org/appshell/window-mediator;1"]
            .getService(Components.interfaces.nsIWindowMediator)
            .getMostRecentWindow("navigator:browser");
    }


    this.MyOnClick = function() {
       this.StartScan();
    }

    this.MyOnFeedback = function() {
        this.MyGetWindow().content.document.location = "mailto:quickscan@bitdefender.com?subject=Feedback%20message";
    }
    
    this.MyOnUninstall = function() {
        var stringBundle = document.getElementById("bdqscan-string-bundle");

        // Really uninstall Bitdefender QuickScan?
        if(!confirm(stringBundle.getString('reallyUninstall'))) {
            return;
        }
		
        /*this.prefs.setIntPref("numberOfDays", 0);
        this.prefs.setIntPref("lastScanDate", 0);
        this.prefs.setIntPref("lastActionDate", 0);*/
        
        var id = "{e001c731-5e37-4538-a5cb-8168736a2360}";
		
        if(/Firefox\/[4-9]|[1-9][0-9]/.test(navigator.userAgent)) {
            Components.utils.import("resource://gre/modules/AddonManager.jsm");
            AddonManager.getAddonByID(id, function(addon) { addon.uninstall(); });
        } else {
            Components.classes["@mozilla.org/extensions/manager;1"]
                .getService(Components.interfaces.nsIExtensionManager)
                .uninstallItem(id);
        }

        // Bitdefender QuickScan is now uninstalled.\n\n
        // However, changes will be applied after browser restart.
        alert(stringBundle.getString('uninstallDone'));
    }

    this.observe = function() {}

}


//window.addEventListener("load", function() { setTimeout('BDQScan.MyOnLoad()', 1000); }, false);
//window.addEventListener("unload", function() { BDQScan.MyOnUnload(); }, false);